/*
File: Registrar.java
Date		Author		Changes
Mar 07 97	Lukasz Beca	Created
11  13 97   K Olszewski changed application start
*/
 
package webwisdom.tango.structures;

import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.interfaces.ControlAppletBase;
import webwisdom.tango.interfaces.AppletBaseInterf;
import webwisdom.tango.structures.ApplicationHandle;
import webwisdom.tango.structures.AppletHandle;
import webwisdom.tango.structures.ScriptHandle;
import webwisdom.tango.structures.BeanHandle;
import webwisdom.tango.beans.TangoBean;
import java.net.ServerSocket;
import java.net.Socket;
import netscape.javascript.JSObject;
import webwisdom.tango.threads.AppThreadIn;
import webwisdom.tango.threads.AppThreadOut;
import webwisdom.tango.consts.Const;
import netscape.security.PrivilegeManager;

import webwisdom.tango.threads.AcceptThread;

public class Registrar {

  private LocalApplications apps;
  private ControlApplication ca;
  private AcceptThread accth;
  private int port;
  

  public Registrar(int portpar) {
   
    apps = null;
    ca = null;

    if (portpar > 0) {
      port = portpar;
      initSocket();

    } else {
      
        port = 0;
	accth = null;
        ca.errorRegistrar(Const.FILEWRONGFORMAT);

    }

  }
  //interface for LocalBase
  //public void initAssociations(ControlApplication capar, LocalApplications lapar);
  
  public void initAssociations(ControlApplication capar, LocalApplications lapar) {

    ca = capar;
    apps = lapar;

  }

 

  //interface for Control Application
  //public ControlApplication registerCA(ControlAppletBase cab);
  //public int getLocalPort();
  //public void end();

  public ControlApplication registerCA(ControlAppletBase cab) {

    if (ca != null) {    
      ca.init(cab);
    }
    
    return ca;

  }

  public int getLocalPort() {

    return port;

  }

  public void end() {

    apps = null;
    ca = null;
    accth.stop();
    accth = null;
    port = 0;


  }


  //interface for Applets
  //public void registerApplet(AppletBase ab);  

  public AppletHandle registerApplet(AppletBaseInterf applet, int AID, int SID, int AT) {

    AppletHandle h = new AppletHandle(applet, AID, apps);

    System.out.println("Registrar: new applet registered with AID" + AID + " SID " + SID + " AT " + AT);	
    apps.addApplication(h, AID, SID);
    ca.addApplication(AID, SID, AT);

    return h;


  }

  //interface for Scripts
  //public void registerScript(JSObject script);

  public ScriptHandle registerScript(JSObject script, String AIDs, String SIDs, String ATs) {

    int SID, AT, AID;
    ScriptHandle h;
 
    try {   
      
 			 AID = Integer.parseInt(AIDs);
		  	SID = Integer.parseInt(SIDs);
		 	 AT = Integer.parseInt(ATs);
			 
			 System.out.println("Registrar: script AID " + AID + " SID " + SID + " AT " + AT);

		
    		h = new ScriptHandle(script, AID, apps);

    		System.out.println("Registrar: new script registered with AID" + AID + " SID " + SID + " AT " + AT);	
    		apps.addApplication(h, AID, SID);
    		ca.addApplication(AID, SID, AT);
    
    } catch (Exception e) {
        System.out.println("AID not found");     					
    				e.printStackTrace();
				 return null;
		}


    return h;

  }
  
  
   //interface for Beans
  //public void registerBean();

  public BeanHandle registerBean(TangoBean tb, JSObject window, int AID, int SID, int AT) {

      BeanHandle h;
 
    try {   
      
 					 
		System.out.println("Registrar: script AID " + AID + " SID " + SID + " AT " + AT);

		
    		h = new BeanHandle(tb, window, AID, apps);

    		System.out.println("Registrar: new bean registered with AID" + AID + " SID " + SID + " AT " + AT);	
    		apps.addApplication(h, AID, SID);
    		ca.addApplication(AID, SID, AT);
    
    } catch (Exception e) {
        System.out.println("Registrar: AID not found");     					
    				e.printStackTrace();
				 return null;
		}


    return h;

  }



  //interface for AppThreadIn (Applications)
  //public void registerApplication();
  public ApplicationHandle registerApplication(AppThreadIn in, AppThreadOut out, int AID, int SID, int AT) {

    ApplicationHandle apph;
    
    apph = new ApplicationHandle(in, out);    
    apps.addApplication(apph, AID, SID); 
    ca.addApplication(AID, SID, AT);  
    
    return apph;
  }


  //inteface for AcceptThread
  //public void errorAcc();
  //public void handleConnection(Socket sock);
 
  public void errorAcc() {}
  public void handleConnection(Socket sock) {

    AppThreadIn i;
    AppThreadOut o;
  
    if (sock != null) {
      System.out.println("Local: Connection accepted, starting application threads ......");
      o = new AppThreadOut(sock);
      i = new AppThreadIn(sock, o, apps, this);
    }
  }

  //internal methods
  //private void initSocket();

  private void initSocket() {

    ServerSocket s = null; 
    int bound = port + 100;
    boolean connected = false; 

    PrivilegeManager.enablePrivilege("30Capabilities");

    while(port < bound && !connected) {
      try {
     
       s = new ServerSocket(port);
       connected = true;
      } catch(Exception e) {
	  
        System.out.println("Registrar: Err: " + e);
 	System.out.println("Registrar: trying another port");
 	port ++;
      }
            
    }

    if (port == bound) {

      System.out.println("Registrar: unable to start listening on port");    
      ca.errorRegistrar(Const.UNABLETOLISTEN);
      return;

    }

    accth = new AcceptThread(s, this);

  } 

	private void addApplication(int AID, int SID, int AT) {
	
		ca.addApplication(AID, SID, AT);
	
	}

}


